/* 
Module MAC (Medium Access Control) for Morse communications 
Date: 7-11-20

Version with finish transmission Callback and message priority
*/

#ifndef LAN_H
#define LAN_H

#include <stdint.h>
#include <stdbool.h>
#include <pbn.h>

#define MAX_MSS_LAN (MAX_ME_ETH - 4) //4 Bytes is overload of Lan layer pdu
typedef uint8_t morse_c_t;
typedef morse_c_t message_lan_t[MAX_MSS_LAN];

void lan_init (morse_c_t no);
/* Initialization
   Parameter: Origin Node ID */

/*****************************************************************************/
/*               Tx functions                                                */
/*****************************************************************************/
typedef void (*lc_fintx_t)(void); //Callback when finish transmission message
typedef enum {low, high} priority_t;

bool lan_can_put (priority_t p);
/* Has to be called before lan_block_put() */

void lan_block_put (const message_lan_t m, morse_c_t nd, priority_t p, lc_fintx_t cf);
/* Non blocking.
   Parameters: - message_lan_t 
               - Destination Node ID */

/*****************************************************************************/
/*                  Rx functions                                             */
/*****************************************************************************/
typedef void (*lc_messrx_t)(void); //Callback when a message is received
morse_c_t lan_block_get (message_lan_t m);
void on_lan_received (lc_messrx_t cm);


#endif
